import { AuthenticateCustomerPayload, FunctionInfo, FunctionLog, PAT, Project, SimpleProjectInfo } from '../types/common';
import { GraphQLClient } from 'graphql-request';
import { Config } from '../Config';
import { Environment } from 'graphcool-yml';
import { Output } from '../index';
export declare class Client {
    config: Config;
    env: Environment;
    out: Output;
    mock: (input: {
        request: any;
        response: any;
    }) => void;
    private mocks;
    private tokenCache;
    constructor(config: Config, environment: Environment, out: Output);
    readonly client: GraphQLClient;
    introspect(serviceName: string, stageName: string, token?: string): Promise<any>;
    addProject(name: string, stage: string, secrets: string[] | null): Promise<SimpleProjectInfo>;
    getDeployUrl(projectId: string): Promise<string>;
    deploy(name: string, stage: string, types: string, dryRun: boolean, secrets: string[] | null): Promise<any>;
    listProjects(): Promise<Project[]>;
    resetServiceData(id: string): Promise<void>;
    waitForLocalDocker(endpoint: string): Promise<void>;
    waitForMigration(name: string, stage: string, revision: number): Promise<void>;
    authenticateCustomer(endpoint: string, token: string): Promise<AuthenticateCustomerPayload>;
    getPats(projectId: string): Promise<PAT[]>;
    getFunctions(projectId: string): Promise<FunctionInfo[]>;
    getFunction(projectId: string, functionName: string): Promise<FunctionInfo | null>;
    getFunctionLogs(functionId: string, count?: number): Promise<FunctionLog[] | null>;
    getAllFunctionLogs(projectId: string, count?: number): Promise<FunctionLog[] | null>;
    getProjectName(projectId: string): Promise<string>;
    deleteProjects(projectIds: string[]): Promise<string[]>;
    exportProjectData(projectId: string): Promise<string>;
}
